import math

class Koordinate:
	__slots__ = ["x", "y"]
	def __init__(self, x = 0.0, y = 0.0):
		self.x = x; self.y = y

class Smer:
	__slots__ = ["d", "v"]
	def __init__(self, d = 0.0, v = 0.0):
		self.d = d; self.v = v

class Stanje:
	__slots__ = ["koord", "smer"]
	def __init__(self, x, y, d, v):
		self.koord = Koordinate(x, y)
		self.smer = Smer(d, v)
	def __str__(self):
		return "%8.6f %8.6f %8.3f %5.4f" % (
			self.koord.x, self.koord.y, self.smer.d * 180.0 / math.pi, self.smer.v)

pasmaNobena = 0
pasmaMuca = 1
pasmaMis = 2
razlogNapaka = 0
razlogZmagala = 1
razlogZgubila = 2

MAX_SPREMEMBA_SMERI = 5 * math.pi / 180.0
MAX_SPREMEMBA_HITROSTI = 0.001
DOSEG_LOVCA = 0.01
MAX_KORAKOV = 3000

class Zival:
	tip = pasmaMuca
	ime = "PyMuca"
	def __init__(self): pass
	def ZbudiSe(self, jaz, nasprotnik):
		ZeljenaSmer = 0.0
		# Tu dodaj svojo implementacijo.
		print "ZbudiSe: jaz %8.6f %8.3f nasprotnik %8.6f %8.6f -> ZeljenaSmer %8.3f" % (jaz.x, jaz.y, nasprotnik.x, nasprotnik.y, ZeljenaSmer * 180.0 / math.pi)
		return ZeljenaSmer
	def KamGres(self, jaz, nasprotnik):
		# Tu dodaj svojo implementacijo.  Spodnja macka zgolj tece v majhnem krogu.
		SpremembaSmeri = 1.0
		if jaz.smer.v < 0.005: SpremembaHitrosti = 1.0
		else: SpremembaHitrosti = 0.0
		#
		print "ZeljenaSmer: jaz %s nasprotnik %s -> dSmer %g dV %g" % (
			str(jaz), str(nasprotnik), SpremembaSmeri * 180.0 / math.pi, SpremembaHitrosti)
		return (SpremembaSmeri, SpremembaHitrosti)
	def KonecIgre(self, razlog):
		print "KonecIgre: razlog = %s" % {razlogNapaka: "napaka", razlogZmagala: "zmagala", razlogZgubila: "zgubila"}.get(razlog, str(razlog))

